//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-station.cm"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  clrBlue
#property indicator_color2  clrRed
#property indicator_color3  clrBlue
#property indicator_color4  clrRed
#property indicator_color5  clrBlue
#property indicator_color6  clrRed
#property indicator_color7  clrBlue
#property indicator_color8  clrRed
#property indicator_minimum 0
#property indicator_maximum 5

//
//
//

enum enTimeFrames
{
   tf_cu  = PERIOD_CURRENT, // Current time frame
   tf_m1  = PERIOD_M1,      // 1 minute
   tf_m5  = PERIOD_M5,      // 5 minutes
   tf_m15 = PERIOD_M15,     // 15 minutes
   tf_m30 = PERIOD_M30,     // 30 minutes
   tf_h1  = PERIOD_H1,      // 1 hour
   tf_h4  = PERIOD_H4,      // 4 hours
   tf_d1  = PERIOD_D1,      // Daily
   tf_w1  = PERIOD_W1,      // Weekly
   tf_mn1 = PERIOD_MN1,     // Monthly
   tf_n1  = -1,             // First higher time frame
   tf_n2  = -2,             // Second higher time frame
   tf_n3  = -3              // Third higher time frame
};
extern enTimeFrames TimeFrame1            = tf_cu;  // First time frame
extern enTimeFrames TimeFrame2            = tf_n1;
extern enTimeFrames TimeFrame3            = tf_n2;
extern enTimeFrames TimeFrame4            = tf_n3;
extern int          SignalPeriod          = 13;
enum  enMaTypes
      {
         ma_sma,     // Simple moving average
         ma_ema,     // Exponential moving average
         ma_smma,    // Smoothed MA
         ma_lwma,    // Linear weighted MA
         ma_tema,    // Triple exponential moving average
         ma_hull     // Hull moving average
      };
extern enMaTypes    SignalMaMode          = ma_lwma;
extern string       UniqueID              = "4 TF Obv2";
extern bool         alertsOn              = false;
extern int          alertsLevel           = 3;
extern bool         alertsMessage         = true;
extern bool         alertsSound           = false;
extern bool         alertsEmail           = false;
input bool          alertsNotify          = false;
extern int          LinesWidth            = 0;
extern color        LabelsColor           = clrDarkGray;
extern int          LabelsHorizontalShift = 5;
extern double       LabelsVerticalShift   = 1.5;

double obv1u[],obv1d[],obv2u[],obv2d[],obv3u[],obv3d[],obv4u[],obv4d[];
int    timeFrames[4];
bool   returnBars;
bool   calculateValue;
string indicatorFileName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int OnInit()
{
   SetIndexBuffer(0,obv1u,INDICATOR_DATA);
   SetIndexBuffer(1,obv1d,INDICATOR_DATA);
   SetIndexBuffer(2,obv2u,INDICATOR_DATA);
   SetIndexBuffer(3,obv2d,INDICATOR_DATA);
   SetIndexBuffer(4,obv3u,INDICATOR_DATA);
   SetIndexBuffer(5,obv3d,INDICATOR_DATA);
   SetIndexBuffer(6,obv4u,INDICATOR_DATA);
   SetIndexBuffer(7,obv4d,INDICATOR_DATA);
 
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame1==-99); if (returnBars)     return(0);
      calculateValue    = (TimeFrame1==-98); if (calculateValue) return(0);
      
      //
      //
      //
      
      for (int i=0; i<8; i++) { SetIndexStyle(i,DRAW_ARROW,EMPTY,LinesWidth); SetIndexArrow(i,110); }
      
      timeFrames[0] = timeFrameValue(TimeFrame1);
      timeFrames[1] = timeFrameValue(TimeFrame2);
      timeFrames[2] = timeFrameValue(TimeFrame3);
      timeFrames[3] = timeFrameValue(TimeFrame4);

      alertsLevel = fmin(fmax(alertsLevel,3),4);

      IndicatorSetString(INDICATOR_SHORTNAME,UniqueID);
return(INIT_SUCCEEDED);
}
int deinit()
{
   for (int t=0; t<4; t++) ObjectDelete(UniqueID+t);
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double trend[][2];
#define _up 0
#define _dn 1
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { obv1u[0] = limit+1; return(0); }
         if (calculateValue) { calculateByOBV(limit); return(0); }

         if (timeFrames[0] != _Period) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[0],indicatorFileName,-99,0,0)*timeFrames[0]/_Period));
         if (timeFrames[1] != _Period) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[1],indicatorFileName,-99,0,0)*timeFrames[1]/_Period));
         if (timeFrames[2] != _Period) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[2],indicatorFileName,-99,0,0)*timeFrames[2]/_Period));
         if (timeFrames[3] != _Period) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[3],indicatorFileName,-99,0,0)*timeFrames[3]/_Period));
         if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);

         //
         //
         //
         //
         //
         
         bool initialized = false;
         if (!initialized)
         {
            initialized = true;
            int window = WindowFind(UniqueID);
            for (int t=0; t<4; t++)
            {
               string label = timeFrameToString(timeFrames[t]);
               ObjectCreate(UniqueID+t,OBJ_TEXT,window,0,0);
                  ObjectSet(UniqueID+t,OBJPROP_COLOR,LabelsColor);
                  ObjectSet(UniqueID+t,OBJPROP_PRICE1,t+LabelsVerticalShift);
                  ObjectSetText(UniqueID+t,label,8,"Arial");
            }               
         }
         for (t=0; t<4; t++) ObjectSet(UniqueID+t,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);

   //
   //
   //
   //
   //
    
   for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
   {
      trend[r][_up] = 0;
      trend[r][_dn] = 0;
      for (int k=0; k<4; k++)
      {
         int y = iBarShift(NULL,timeFrames[k],Time[i]);
            double spanA = iCustom(NULL,timeFrames[k],indicatorFileName,-98,0,0,0,SignalPeriod,SignalMaMode,0,y);
            bool   isUp  = (spanA>0);
            switch (k)
            {
               case 0 : if (isUp) { obv1u[i] = k+1; obv1d[i] = EMPTY_VALUE;}  else { obv1d[i] = k+1; obv1u[i] = EMPTY_VALUE; } break;
               case 1 : if (isUp) { obv2u[i] = k+1; obv2d[i] = EMPTY_VALUE;}  else { obv2d[i] = k+1; obv2u[i] = EMPTY_VALUE; } break;
               case 2 : if (isUp) { obv3u[i] = k+1; obv3d[i] = EMPTY_VALUE;}  else { obv3d[i] = k+1; obv3u[i] = EMPTY_VALUE; } break;
               case 3 : if (isUp) { obv4u[i] = k+1; obv4d[i] = EMPTY_VALUE;}  else { obv4d[i] = k+1; obv4u[i] = EMPTY_VALUE; } break;
            }
            if (isUp)
                  trend[r][_up] += 1;
            else  trend[r][_dn] += 1;
      }
   }
   manageAlerts();
   return(0);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------

void calculateByOBV(int limit)
{
   for (int i=limit; i>=0; i--) 
   {
       if (i==(Bars-1)) 
       { 
            obv4u[i] = Volume[i];
       }
       else            
       {
          if ((High[i] == Low[i] ) || (Open[i] == Close[i]) || (Close[i] == Close[i+1]))
          { 
            obv4u[i] = obv4u[i+1];
          }
          else  
          { 
            if (Close[i]>Open[i]) obv4u[i] = obv4u[i+1] + (Volume[i] * (Close[i] - Open[i]) /  (High[i] - Low[i]));
            else                  obv4u[i] = obv4u[i+1] - (Volume[i] * (Open[i]  - Close[i]) / (High[i] - Low[i]));
          } 
       }   
       obv4d[i] = iCustomMa(SignalMaMode,obv4u[i],SignalPeriod,i,Bars); 
       obv1u[i] = (i<Bars-1) ? (obv4u[i]>obv4d[i]) ? 1 : (obv4u[i]<obv4d[i]) ? -1 : obv1u[i+1]  : 0;  // obv=obv4u ma=obv4d trend=obv1u
       obv3u[i] = (obv1u[i] ==  1) ? 1 : EMPTY_VALUE;
       obv3d[i] = (obv1u[i] == -1) ? 1 : EMPTY_VALUE;
      
     }
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------

string getAvgName(int method)
{
      switch(method)
      {
         case ma_ema:    return("EMA");
         case ma_lwma:   return("LWMA");
         case ma_sma:    return("SMA");
         case ma_smma:   return("SMMA");
         case ma_hull:   return("HMA");
         case ma_tema:   return("TEMA");
      }
return("");      
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------

#define _maInstances 1
#define _maWorkBufferx1 1*_maInstances
#define _maWorkBufferx2 2*_maInstances
#define _maWorkBufferx3 3*_maInstances

double iCustomMa(int mode, double price, double length, int r, int bars, int instanceNo=0)
{
   r = bars-r-1;
   switch (mode)
   {
      case ma_sma   : return(iSma(price,(int)ceil(length),r,bars,instanceNo));
      case ma_ema   : return(iEma(price,length,r,bars,instanceNo));
      case ma_smma  : return(iSmma(price,(int)ceil(length),r,bars,instanceNo));
      case ma_lwma  : return(iLwma(price,(int)ceil(length),r,bars,instanceNo));
      case ma_tema  : return(iTema(price,length,r,bars,instanceNo));
      case ma_hull  : return(iHull(price,length,r,bars,instanceNo));
      default       : return(price);
   }
}

//
//
//

double workSma[][_maWorkBufferx1];
double iSma(double price, int period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= _bars) ArrayResize(workSma,_bars);

   workSma[r][instanceNo+0] = price;
   double avg = price; int k=1;  for(; k<period && (r-k)>=0; k++) avg += workSma[r-k][instanceNo+0];  
   return(avg/(double)k);
}

//
//
//

double workEma[][_maWorkBufferx1];
double iEma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= _bars) ArrayResize(workEma,_bars);

   workEma[r][instanceNo] = price;
   if (r>0 && period>1)
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+(2.0/(1.0+period))*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//
//
//

double workSmma[][_maWorkBufferx1];
double iSmma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workSmma,0)!= _bars) ArrayResize(workSmma,_bars);

   workSmma[r][instanceNo] = price;
   if (r>1 && period>1)
          workSmma[r][instanceNo] = workSmma[r-1][instanceNo]+(price-workSmma[r-1][instanceNo])/period;
   return(workSmma[r][instanceNo]);
}

//
//
//

double workLwma[][_maWorkBufferx1];
double iLwma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workLwma,0)!= _bars) ArrayResize(workLwma,_bars);
   
   workLwma[r][instanceNo] = price; if (period<=1) return(price);
      double sumw = period;
      double sum  = period*price;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = period-k;
                sumw  += weight;
                sum   += weight*workLwma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}

//
//
//

double workTema[][_maWorkBufferx3];
#define _tema1 0
#define _tema2 1
#define _tema3 2

double iTema(double price, double period, int r, int bars, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(workTema,0)!= bars) ArrayResize(workTema,bars); instanceNo*=3;

   //
   //
   //
      
   workTema[r][_tema1+instanceNo] = price;
   workTema[r][_tema2+instanceNo] = price;
   workTema[r][_tema3+instanceNo] = price;
   double alpha = 2.0 / (1.0+period);
   if (r>0)
   {
          workTema[r][_tema1+instanceNo] = workTema[r-1][_tema1+instanceNo]+alpha*(price                         -workTema[r-1][_tema1+instanceNo]);
          workTema[r][_tema2+instanceNo] = workTema[r-1][_tema2+instanceNo]+alpha*(workTema[r][_tema1+instanceNo]-workTema[r-1][_tema2+instanceNo]);
          workTema[r][_tema3+instanceNo] = workTema[r-1][_tema3+instanceNo]+alpha*(workTema[r][_tema2+instanceNo]-workTema[r-1][_tema3+instanceNo]); }
   return(workTema[r][_tema3+instanceNo]+3.0*(workTema[r][_tema1+instanceNo]-workTema[r][_tema2+instanceNo]));
}

//
//
//

double workHull[][_maWorkBufferx2];
double iHull(double price, double period, int r, int bars, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(workHull,0)!= bars) ArrayResize(workHull,bars);

   //
   //
   //

      int HmaPeriod  = (int)fmax(period,2);
      int HalfPeriod = (int)floor(HmaPeriod/2);
      int HullPeriod = (int)floor(sqrt(HmaPeriod));
      double hma,hmw,weight; instanceNo *= 2;

         workHull[r][instanceNo] = price;

         //
         //
         //
               
         hmw = HalfPeriod; hma = hmw*price; 
            for(int k=1; k<HalfPeriod && (r-k)>=0; k++)
            {
               weight = HalfPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][instanceNo];  
            }             
            workHull[r][instanceNo+1] = 2.0*hma/hmw;

         hmw = HmaPeriod; hma = hmw*price; 
            for(k=1; k<period && (r-k)>=0; k++)
            {
               weight = HmaPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][instanceNo];
            }             
            workHull[r][instanceNo+1] -= hma/hmw;

         //
         //
         //
         
         hmw = HullPeriod; hma = hmw*workHull[r][instanceNo+1];
            for(k=1; k<HullPeriod && (r-k)>=0; k++)
            {
               weight = HullPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][1+instanceNo];  
            }
   return(hma/hmw);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = Bars-1; 
      static datetime time1 = 0;
      static string   mess1 = "";
      if (trend[whichBar][_up]>=alertsLevel || trend[whichBar][_dn]>=alertsLevel)
      {
         if (trend[whichBar][_up] >= alertsLevel && trend[whichBar-1][_up]<alertsLevel) doAlert(time1,mess1,whichBar,"up",trend[whichBar][_up]);
         if (trend[whichBar][_dn] >= alertsLevel && trend[whichBar-1][_dn]<alertsLevel) doAlert(time1,mess1,whichBar,"down",trend[whichBar][_dn]);
      }              
    }         
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat, int howMany)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

        message =  _Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" "+howMany+" time frames of OBV2 are aligned "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(_Symbol+" 4 time frame OBV2",message);
          if (alertsNotify)  SendNotification(message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int timeFrameValue(int _tf)
{
   int add  = (_tf>=0) ? 0 : MathAbs(_tf);
   if (add != 0) _tf = _Period;
   int size = ArraySize(iTfTable); 
      int i =0; for (;i<size; i++) if (iTfTable[i]==_tf) break;
                                   if (i==size) return(_Period);
                                                return(iTfTable[(int)MathMin(i+add,size-1)]);
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
